#!/usr/bin/env python

class Branch:
    def __init__(self, nodes):
        self.nodes = nodes

class Leaf:
    def __init__(self, value):
        self.value = value

class Visitor:
    def visit(self, node):
        method = getattr(self, node.__class__.__name__)
        return method(node)

    # Visitor-specific functionality.
    # Note that getattr does not support "visit" + __class__.__name__.

    def Branch(self, node):
        sum = 0
        for node in node.nodes:
            sum += self.visit(node)
        return sum

    def Leaf(self, node):
        return node.value

tree = \
    Branch((
        Branch((
            Leaf(10),
            Leaf(5)
            )),
        Leaf(2)
        ))

visitor = Visitor()
result_17 = visitor.visit(tree)

# vim: tabstop=4 expandtab shiftwidth=4
